#include <windows.h>
#include <conio.h>
#include "fmod_event.hpp"

int main(int argc, char* argv[])
{
	// Add error checks!
	FMOD::EventSystem *eventSystem;
	FMOD::EventSystem_Create(&eventSystem);
	eventSystem->init(1000, FMOD_INIT_NORMAL, 0);
	eventSystem->setMediaPath("C:/Programme/FMOD SoundSystem/FMOD Designer/examples/media");
	eventSystem->load("examples.fev", NULL, NULL);

	FMOD::EventGroup *eventGroup;
	eventSystem->getGroup("examples/examples/car", FMOD_EVENT_DEFAULT, &eventGroup);
	FMOD::Event *car;
	eventGroup->getEvent("car", FMOD_EVENT_DEFAULT, &car);
	FMOD::EventParameter *load;
	car->getParameter("load", &load);
	float loadRangeMin, loadRangeMax;
	load->getRange(&loadRangeMin, &loadRangeMax);
	load->setValue(loadRangeMax);
	FMOD::EventParameter *rpm;
	car->getParameter("rpm", &rpm);
	float rpmRangeMin, rpmRangeMax;
	rpm->getRange(&rpmRangeMin, &rpmRangeMax);
	rpm->setValue(0.9f*rpmRangeMin+0.1f*rpmRangeMax);
    
	car->start();

	while(true)
	{
		if(kbhit())
		{
			int key = getch();
			if(key == ' ')
			{
				break;
			}
			else if(key = 'a')
			{
				float value;
				rpm->getValue(&value);
				value += 5.0f;
				if(value > rpmRangeMax)
				{
					value = rpmRangeMax;
				}
				rpm->setValue(value);
			}
		}

		Sleep(10);
		eventSystem->update();
	}

	eventGroup->freeEventData();
	eventSystem->release();
	return 0;
}

