#include <windows.h>
#include <conio.h>
#include "fmod.hpp"

int main(int argc, char* argv[])
{
	// Add error checks!
	FMOD::System *system;
	FMOD::System_Create(&system);
	system->init(100, FMOD_INIT_NORMAL, 0);

	FMOD::DSP *dsp1;
	system->createDSPByType(FMOD_DSP_TYPE_FLANGE, &dsp1);
	system->addDSP(dsp1);

	FMOD::DSP *dsp2;
	system->createDSPByType(FMOD_DSP_TYPE_SFXREVERB, &dsp2);
	system->addDSP(dsp2);
	dsp2->setParameter(FMOD_DSP_SFXREVERB_DECAYTIME, 10.0);

	// a .wav file
	FMOD::Sound *s1;
	system->createSound("../dong.wav", FMOD_CREATESAMPLE, NULL, &s1);
	FMOD::Channel *c1;
	system->playSound(FMOD_CHANNEL_FREE, s1, false, &c1);

	// a .mid file
	FMOD::Sound *s2;
	system->createSound("../piano.mid", FMOD_CREATESAMPLE, NULL, &s2);
	FMOD::Channel *c2;
	system->playSound(FMOD_CHANNEL_FREE, s2, false, &c2);

	// streaming a longer file
	FMOD::Sound *s3;
	system->createStream("../horns.wav", FMOD_DEFAULT, NULL, &s3);
	FMOD::Channel *c3;
	system->playSound(FMOD_CHANNEL_FREE, s3, false, &c3);

	// DSP effects require FMOD_SOFTWARE
	FMOD::Sound *s4;
	system->createSound("../horns.wav", FMOD_SOFTWARE, 0, &s4);
	FMOD::Channel *c4;
	//system->playSound(FMOD_CHANNEL_FREE, s4, false, &c4);

	while(!kbhit())
	{
		Sleep(10);
		system->update();
	}

	s1->release();
	s2->release();
	s3->release();
	s4->release();
	dsp1->release();
	dsp2->release();
	system->release();
	return 0;
}